/*
  Register definitions for slave core: FMC masterFIP core registers

  * File           : fmc_masterfip_csr.h
  * Author         : auto-generated by wbgen2 from masterfip.wb
  * Created        : 07/17/15 16:59:50
  * Standard       : ANSI C

    THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE masterfip.wb
    DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!

*/

#ifndef __WBGEN2_REGDEFS_MASTERFIP_WB
#define __WBGEN2_REGDEFS_MASTERFIP_WB

#include <inttypes.h>

#if defined( __GNUC__)
#define PACKED __attribute__ ((packed))
#else
#error "Unsupported compiler?"
#endif

#ifndef __WBGEN2_MACROS_DEFINED__
#define __WBGEN2_MACROS_DEFINED__
#define WBGEN2_GEN_MASK(offset, size) (((1<<(size))-1) << (offset))
#define WBGEN2_GEN_WRITE(value, offset, size) (((value) & ((1<<(size))-1)) << (offset))
#define WBGEN2_GEN_READ(reg, offset, size) (((reg) >> (offset)) & ((1<<(size))-1))
#define WBGEN2_SIGN_EXTEND(value, bits) (((value) & (1<<bits) ? ~((1<<(bits))-1): 0 ) | (value))
#endif


/* definitions for register: rst */

/* definitions for field: reset of the masterFIP core in reg: rst */
#define MF_RST_CORE_MASK                      WBGEN2_GEN_MASK(0, 1)
#define MF_RST_CORE_SHIFT                     0
#define MF_RST_CORE_W(value)                  WBGEN2_GEN_WRITE(value, 0, 1)
#define MF_RST_CORE_R(reg)                    WBGEN2_GEN_READ(reg, 0, 1)

/* definitions for field: reset of the fieldrive chip (FD_RSTN) in reg: rst */
#define MF_RST_FD_MASK                        WBGEN2_GEN_MASK(1, 1)
#define MF_RST_FD_SHIFT                       1
#define MF_RST_FD_W(value)                    WBGEN2_GEN_WRITE(value, 1, 1)
#define MF_RST_FD_R(reg)                      WBGEN2_GEN_READ(reg, 1, 1)

/* definitions for field: reset magic value in reg: rst */
#define MF_RST_LOCK_MASK                      WBGEN2_GEN_MASK(16, 16)
#define MF_RST_LOCK_SHIFT                     16
#define MF_RST_LOCK_W(value)                  WBGEN2_GEN_WRITE(value, 16, 16)
#define MF_RST_LOCK_R(reg)                    WBGEN2_GEN_READ(reg, 16, 16)

/* definitions for register: id */

/* definitions for register: config from host */

/* definitions for field: bit rate in reg: config from host */
#define MF_CONFIG_HOST_BITRATE_MASK           WBGEN2_GEN_MASK(0, 2)
#define MF_CONFIG_HOST_BITRATE_SHIFT          0
#define MF_CONFIG_HOST_BITRATE_W(value)       WBGEN2_GEN_WRITE(value, 0, 2)
#define MF_CONFIG_HOST_BITRATE_R(reg)         WBGEN2_GEN_READ(reg, 0, 2)

/* definitions for field: termination enable on the external synch input in reg: config from host */
#define MF_CONFIG_HOST_EXT_SYNC_TERM_EN_N     WBGEN2_GEN_MASK(2, 1)

/* definitions for field: station address in reg: config from host */
#define MF_CONFIG_HOST_SUBS_MASK              WBGEN2_GEN_MASK(8, 8)
#define MF_CONFIG_HOST_SUBS_SHIFT             8
#define MF_CONFIG_HOST_SUBS_W(value)          WBGEN2_GEN_WRITE(value, 8, 8)
#define MF_CONFIG_HOST_SUBS_R(reg)            WBGEN2_GEN_READ(reg, 8, 8)

/* definitions for register: config from fmc */

/* definitions for field: bit rate in reg: config from fmc */
#define MF_CONFIG_FMC_BITRATE_MASK            WBGEN2_GEN_MASK(0, 2)
#define MF_CONFIG_FMC_BITRATE_SHIFT           0
#define MF_CONFIG_FMC_BITRATE_W(value)        WBGEN2_GEN_WRITE(value, 0, 2)
#define MF_CONFIG_FMC_BITRATE_R(reg)          WBGEN2_GEN_READ(reg, 0, 2)

/* definitions for field: bit rate match in reg: config from fmc */
#define MF_CONFIG_FMC_BITRATE_OK              WBGEN2_GEN_MASK(31, 1)

/* definitions for register: macrocycle lgth */

/* definitions for register: turnaround time */

/* definitions for register: silence time */

/* definitions for register: macrocycle time cnt */

/* definitions for register: turnaround time cnt */

/* definitions for register: ext sync tstamp */

/* definitions for register: tx ctrl */

/* definitions for field: tx rst in reg: tx ctrl */
#define MF_TX_RST                             WBGEN2_GEN_MASK(0, 1)

/* definitions for field: tx strt in reg: tx ctrl */
#define MF_TX_START                           WBGEN2_GEN_MASK(1, 1)

/* definitions for field: tx number of bytes in reg: tx ctrl */
#define MF_TX_BYTES_NUM_MASK                  WBGEN2_GEN_MASK(8, 9)
#define MF_TX_BYTES_NUM_SHIFT                 8
#define MF_TX_BYTES_NUM_W(value)              WBGEN2_GEN_WRITE(value, 8, 9)
#define MF_TX_BYTES_NUM_R(reg)                WBGEN2_GEN_READ(reg, 8, 9)

/* definitions for register: tx status */

/* definitions for field: tx stopped in reg: tx status */
#define MF_TX_STOP                            WBGEN2_GEN_MASK(0, 1)

/* definitions for register: fieldrive status */

/* definitions for field: fd watchdog in reg: fieldrive status */
#define MF_FD_WDGN                            WBGEN2_GEN_MASK(0, 1)

/* definitions for field: fd transmitter error in reg: fieldrive status */
#define MF_FD_TXER                            WBGEN2_GEN_MASK(1, 1)

/* definitions for register: rx ctrl */

/* definitions for field: rx rst in reg: rx ctrl */
#define MF_RX_RST                             WBGEN2_GEN_MASK(0, 1)

/* definitions for register: rx status */

/* definitions for field: rx preamble detected in reg: rx status */
#define MF_RX_PREAM_OK                        WBGEN2_GEN_MASK(0, 1)

/* definitions for field: rx frame ok in reg: rx status */
#define MF_RX_FRAME_OK                        WBGEN2_GEN_MASK(1, 1)

/* definitions for field: rx frame error in reg: rx status */
#define MF_RX_FRAME_ERR                       WBGEN2_GEN_MASK(2, 1)

/* definitions for field: rx frame error code in reg: rx status */
#define MF_RX_FRAME_ERR_CODE_MASK             WBGEN2_GEN_MASK(3, 3)
#define MF_RX_FRAME_ERR_CODE_SHIFT            3
#define MF_RX_FRAME_ERR_CODE_W(value)         WBGEN2_GEN_WRITE(value, 3, 3)
#define MF_RX_FRAME_ERR_CODE_R(reg)           WBGEN2_GEN_READ(reg, 3, 3)

/* definitions for field: rx number of data bytes in reg: rx status */
#define MF_RX_BYTES_NUM_MASK                  WBGEN2_GEN_MASK(8, 9)
#define MF_RX_BYTES_NUM_SHIFT                 8
#define MF_RX_BYTES_NUM_W(value)              WBGEN2_GEN_WRITE(value, 8, 9)
#define MF_RX_BYTES_NUM_R(reg)                WBGEN2_GEN_READ(reg, 8, 9)
/* [0x0]: REG rst */
#define MF_REG_RST 0x00000000
/* [0x4]: REG id */
#define MF_REG_ID 0x00000004
/* [0x8]: REG config from host */
#define MF_REG_CONFIG_HOST 0x00000008
/* [0xc]: REG config from fmc */
#define MF_REG_CONFIG_FMC 0x0000000c
/* [0x10]: REG macrocycle lgth */
#define MF_REG_MACROCYC_LGTH 0x00000010
/* [0x14]: REG turnaround time */
#define MF_REG_TURNAR_LGTH 0x00000014
/* [0x18]: REG silence time */
#define MF_REG_SILEN_LGTH 0x00000018
/* [0x1c]: REG macrocycle time cnt */
#define MF_REG_MACROCYC_TIME_CNT 0x0000001c
/* [0x20]: REG turnaround time cnt */
#define MF_REG_TURNAR_TIME_CNT 0x00000020
/* [0x24]: REG ext sync tstamp */
#define MF_REG_EXT_SYNC_TSTAMP 0x00000024
/* [0x28]: REG tx ctrl */
#define MF_REG_TX 0x00000028
/* [0x2c]: REG tx status */
#define MF_REG_TX 0x0000002c
/* [0x30]: REG fieldrive status */
#define MF_REG_FD 0x00000030
/* [0x34]: REG rx ctrl */
#define MF_REG_RX 0x00000034
/* [0x38]: REG rx status */
#define MF_REG_RX 0x00000038
#endif
